Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management
Class MBeanInfo

    java.lang.Object
      javax.management.MBeanInfo

All Implemented Interfaces:
  java.lang.Cloneable, java.io.Serializable

Direct Known Subclasses:
  ModelMBeanInfoSupport, OpenMBeanInfoSupport

public class MBeanInfo
extends java.lang.Object
implements java.lang.Cloneable, java.io.Serializable

Describes the management interface exposed by an MBean; that is, the set of attributes and operations which are available for management operations. Instances of this class are immutable. Subclasses may be mutable but this is not recommended.

The contents of the `MBeanInfo` for a Dynamic MBean are determined by its `getMBeanInfo()` method. This includes Open MBeans and Model MBeans, which are kinds of Dynamic MBeans.

The contents of the `MBeanInfo` for a Standard MBean are determined by the MBean server as follows:

- `getClassName()` returns the Java class name of the MBean object;
- `getConstructors()` returns the list of all public constructors in that object;
- `getAttributes()` returns the list of all attributes whose existence is deduced from the presence in the MBean interface of a `getName`, `isName`, or `setName` method that conforms to the conventions for Standard MBeans;
- `getOperations()` returns the list of all methods in the MBean interface that do not represent attributes;
- `getNotifications()` returns an empty array if the MBean does not implement the `NotificationBroadcaster` interface, otherwise the result of calling `NotificationBroadcaster.getNotificationInfo()` on it.

The remaining details of the `MBeanInfo` for a Standard MBean are not specified. This includes the description of the `MBeanInfo` and of any contained constructors, attributes, operations, and notifications; and the names and descriptions of parameters to constructors and operations.

See Also:
  Serialized Form

Constructor Summary
`MBeanInfo(java.lang.String className, java.lang.String description, MBeanAttributeInfo[] attributes, MBeanConstructorInfo[] constructors, MBeanOperationInfo[] operations, MBeanNotificationInfo[] notifications)` Constructs an `MBeanInfo`.

Method Summary
`java.lang.Object` | `clone()` Returns a shallow clone of this instance.
`boolean` | `equals(java.lang.Object o)` Compare this MBeanInfo to another.
`MBeanAttributeInfo[]` | `getAttributes()` Returns the list of attributes exposed for management.
`java.lang.String` | `getClassName()` Returns the name of the Java class of the MBean described by this `MBeanInfo`.
`MBeanConstructorInfo[]` | `getConstructors()` Returns the list of the public constructors of the MBean.
`java.lang.String` | `getDescription()` Returns a human readable description of the MBean.
`MBeanNotificationInfo[]` | `getNotifications()` Returns the list of the notifications emitted by the MBean.
`MBeanOperationInfo[]` | `getOperations()` Returns the list of operations of the MBean.
`int` | `hashCode()`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MBeanInfo

    public MBeanInfo(java.lang.String className,
                     java.lang.String description,
                     MBeanAttributeInfo[] attributes,
                     MBeanConstructorInfo[] constructors,
                     MBeanOperationInfo[] operations,
                     MBeanNotificationInfo[] notifications)
              throws java.lang.IllegalArgumentException

  Constructs an `MBeanInfo`.

Parameters:
  `className` - The name of the Java class of the MBean described by this `MBeanInfo`. This value may be any syntactically legal Java class name. It does not have to be a Java class known to the MBean server or to the MBean's ClassLoader. If it is a Java class known to the MBean's ClassLoader, it is recommended but not required that the class's public methods include those that would appear in a Standard MBean implementing the attributes and operations in this MBeanInfo.
  `description` - A human readable description of the MBean (optional).
  `attributes` - The list of exposed attributes of the MBean. This may be null with the same effect as a zero-length array.
  `constructors` - The list of public constructors of the MBean. This may be null with the same effect as a zero-length array.
  `operations` - The list of operations of the MBean. This may be null with the same effect as a zero-length array.
  `notifications` - The list of notifications emitted. This may be null with the same effect as a zero-length array.

Method Detail

### clone

    public java.lang.Object clone()

  Returns a shallow clone of this instance. The clone is obtained by simply calling `super.clone()`, thus calling the default native shallow cloning mechanism implemented by `Object.clone()`. No deeper cloning of any internal field is made.

  Since this class is immutable, the clone method is chiefly of interest to subclasses.

### getClassName

    public java.lang.String getClassName()

  Returns the name of the Java class of the MBean described by this `MBeanInfo`.

  Returns:
    the class name.

### getDescription

    public java.lang.String getDescription()

  Returns a human readable description of the MBean.

  Returns:
    the description.

### getAttributes

    public MBeanAttributeInfo[] getAttributes()

  Returns the list of attributes exposed for management. Each attribute is described by an `MBeanAttributeInfo` object. The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanAttributeInfo` objects but that each referenced `MBeanAttributeInfo` object is not copied.

  Returns:
    An array of `MBeanAttributeInfo` objects.

### getOperations

    public MBeanOperationInfo[] getOperations()

  Returns the list of operations of the MBean. Each operation is described by an `MBeanOperationInfo` object. The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanOperationInfo` objects but that each referenced `MBeanOperationInfo` object is not copied.

  Returns:
    An array of `MBeanOperationInfo` objects.

### getConstructors

    public MBeanConstructorInfo[] getConstructors()

  Returns the list of the public constructors of the MBean. Each constructor is described by an `MBeanConstructorInfo` object.

  The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanConstructorInfo` objects but that each referenced `MBeanConstructorInfo` object is not copied.

  The returned list is not necessarily exhaustive. That is, the MBean may have a public constructor that is not in the list. In this case, the MBean server can construct another instance of this MBean's class using that constructor, even though it is not listed here.

  Returns:
    An array of `MBeanConstructorInfo` objects.

### getNotifications

    public MBeanNotificationInfo[] getNotifications()

  Returns the list of the notifications emitted by the MBean. Each notification is described by an `MBeanNotificationInfo` object. The returned array is a shallow copy of the internal array, which means that it is a copy of the internal array of references to the `MBeanNotificationInfo` objects but that each referenced `MBeanNotificationInfo` object is not copied.

  Returns:
    An array of `MBeanNotificationInfo` objects.

### equals

    public boolean equals(java.lang.Object o)

  Compare this MBeanInfo to another. Two MBeanInfo objects are equal iff they return equal values for `getClassName()` and for `getDescription()`, and the arrays returned by the two objects for `getAttributes()`, `getOperations()`, `getConstructors()`, and `getNotifications()` are pairwise equal. Here "equal" means `Object.equals(Object)`, not identity.

  If two MBeanInfo objects return the same values in one of their arrays but in a different order then they are not equal.

  Parameters:
    `o` - the object to compare to.
  Returns:
    true iff `o` is an MBeanInfo that is equal to this one according to the rules above.

### hashCode

    public int hashCode()

Overview | Package | Class | Tree | Deprecated | Index | Help
| J2EE1.4 SDK
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature

Copyright 2003 Sun Microsystems, Inc. All rights reserved.